<template>
  <div>

    <v-card>
      <v-card-title class="text-center justify-center py-4" style="background-color: #01A9DB !important; color: #ffffff;">
        <h1 class="font-weight-bold display-2">Noticias</h1>
      </v-card-title>

      <v-tabs
        v-model="tab"
        background-color="transparent"
        color="#ff9800"
        grow
      >
        <v-tab
          v-for="item in items"
          :key="item"
        >
          {{ item }}
        </v-tab>

        <v-tab-item>
          <v-card
            flat
          >
            <v-card-text>
              <v-row>
                <v-col cols=12>
                  <v-expansion-panels>
                    <v-expansion-panel>
                      <v-expansion-panel-header v-slot="{ open }">
                        <v-row dense>
                          <v-col cols="2">Filtros</v-col>
                          <v-col
                            cols="5"
                            class="text--secondary"
                          >
                            <v-fade-transition leave-absolute>
                              <span
                                v-if="!open"
                                key="0"
                              >
                                {{ 'Palabras claves: '+topheadlinesQ }}
                              </span>

                            </v-fade-transition>
                          </v-col>
                          <v-col
                            cols="5"
                            class="text--secondary"
                          >
                            <v-fade-transition leave-absolute>
                              <span
                                v-if="!open"
                                key="0"
                              >
                                {{ (countries.find(obj => obj.abbr == topheadlinescountry)).country }}
                              </span>
                            </v-fade-transition>
                          </v-col>
                        </v-row>
                      </v-expansion-panel-header>
                      <v-expansion-panel-content>
                        <v-row justify="space-around" dense>
                          <v-col cols="5" offset="2" >
                            <v-text-field v-model="topheadlinesQ" label="Palabras clave" @keyup.enter="fetchDataTopHeadlines"></v-text-field>
                          </v-col>

                          <v-col cols="5">
                            <v-select v-model="topheadlinescountry" :items="countries" label="País" item-text="country" item-value="abbr"></v-select>
                          </v-col>

                        </v-row>
                      </v-expansion-panel-content>
                    </v-expansion-panel>
                  </v-expansion-panels>
                </v-col>

                <v-col cols="6" v-for="(article,index) in topHeadlinesArticles" :key="'topheadlines'+index" >
                  <ArticleCard :key="'topheadlinesArticle'+index" :article="article"></ArticleCard>
                </v-col>
              </v-row>
              <v-row align="center" justify="center">
                <v-pagination
                v-model="topheadlinesPage"
                :length="Math.ceil(totalTopHeadlines/10)"
                ></v-pagination>
              </v-row>
            </v-card-text>
          </v-card>
        </v-tab-item>

        <v-tab-item>
          <v-card
            flat
          >
            <v-card-text>
              <v-col cols="12">
                <v-expansion-panels>
                  <v-expansion-panel>
                    <v-expansion-panel-header v-slot="{ open }">
                      <v-row no-gutters>
                        <v-col cols="2">Filtros</v-col>
                        <v-col cols="4" class="text--secondary">
                          <v-fade-transition leave-absolute>
                            <span
                              v-if="!open"
                              key="0"
                            >
                              {{ 'Palabras claves: '+everythingQ }}
                            </span>
                          </v-fade-transition>
                        </v-col>
                        <v-col
                          cols="6"
                          class="text--secondary"
                        >
                          <v-fade-transition leave-absolute>
                            <span v-if="open">Rango de tiempo</span>
                            <v-row
                              v-else
                              no-gutters
                              style="width: 100%"
                            >
                              <v-col cols="6">Fecha inicial: {{ everythingFrom || 'Not set' }}</v-col>
                              <v-col cols="6">Fecha final: {{ everythingTo || 'Not set' }}</v-col>
                            </v-row>
                          </v-fade-transition>
                        </v-col>

                      </v-row>
                    </v-expansion-panel-header>
                    <v-expansion-panel-content>
                      <v-row
                        justify="space-around"
                        no-gutters
                      >
                        <v-col cols="4" offset="1" >
                          <v-text-field  v-model="everythingQ" label="Palabras clave" @keyup.enter="fetchDataEverything"></v-text-field>
                        </v-col>
                        <v-col cols="2">
                          <v-menu
                            ref="startMenu"
                            :close-on-content-click="false"
                            :return-value.sync="everythingFrom"
                            offset-y
                            min-width="290px"
                          >
                            <template v-slot:activator="{ on, attrs }">
                              <v-text-field
                                v-model="everythingFrom"
                                label="Start date"
                                prepend-icon="event"
                                readonly
                                v-bind="attrs"
                                v-on="on"
                              ></v-text-field>
                            </template>
                            <v-date-picker
                              v-model="date"
                              no-title
                              scrollable
                            >
                              <v-spacer></v-spacer>
                              <v-btn
                                text
                                color="primary"
                                @click="$refs.startMenu.isActive = false"
                              >Cancel</v-btn>
                              <v-btn
                                text
                                color="primary"
                                @click="$refs.startMenu.save(date)"
                              >OK</v-btn>
                            </v-date-picker>
                          </v-menu>
                        </v-col>

                        <v-col cols="3">
                          <v-menu
                            ref="endMenu"
                            :close-on-content-click="false"
                            :return-value.sync="everythingTo"
                            offset-y
                            min-width="290px"
                          >
                            <template v-slot:activator="{ on, attrs }">
                              <v-text-field
                                v-model="everythingTo"
                                label="End date"
                                prepend-icon="event"
                                readonly
                                v-bind="attrs"
                                v-on="on"
                              ></v-text-field>
                            </template>
                            <v-date-picker
                              v-model="date"
                              no-title
                              scrollable
                            >
                              <v-spacer></v-spacer>
                              <v-btn
                                text
                                color="primary"
                                @click="$refs.endMenu.isActive = false"
                              >
                                Cancel
                              </v-btn>
                              <v-btn
                                text
                                color="primary"
                                @click="$refs.endMenu.save(date)"
                              >
                                OK
                              </v-btn>
                            </v-date-picker>
                          </v-menu>
                        </v-col>
                      </v-row>
                    </v-expansion-panel-content>
                  </v-expansion-panel>
                </v-expansion-panels>
              </v-col>
              <v-row>
                <v-col cols="6" v-for="(article,index) in everythingArticles" :key="'everything'+index" >
                  <ArticleCard :key="'everythingArticle'+index" :article="article"></ArticleCard>
                </v-col>
              </v-row>
              <v-row align="center" justify="center">
                <v-pagination
                v-model="everythingPage"
                :length="Math.ceil(totalEverything/10)"
                ></v-pagination>
              </v-row>
            </v-card-text>
          </v-card>
        </v-tab-item>
      </v-tabs>
    </v-card>



  </div>
</template>


<script>
// @ is an alias to /src
import ArticleCard from "@/components/ArticleCard.vue";
import { mapState }from 'vuex'

export default {
  name: "NewsList",
  components: {
    ArticleCard
  },
  methods:{
    fetchDataTopHeadlines(){
      this.$store.dispatch('fetchTopHeadlinesArticles',{
        page : this.topheadlinesPage,
        country : this.topheadlinescountry,
        q : this.topheadlinesQ
      })
    },
    fetchDataEverything(){
      this.$store.dispatch('fetchEverythingArticles',{
        page : this.everythingPage,
        q : this.everythingQ,
        from : this.everythingFrom,
        to : this.everythingTo
      })
    }
  },
  data:()=>({
    items:['Titulares destacados','Todo'],
    countries:[{country:"Argentina",abbr:"ar"},{country:"Australia",abbr:"au"},{country:"Austria",abbr:"at"},{country:"Belgium",abbr:"be"},{country:"Brazil",abbr:"br"},{country:"Bulgaria",abbr:"bg"},{country:"Canada",abbr:"ca"},{country:"China",abbr:"cn"},{country:"Colombia",abbr:"co"},{country:"Cuba",abbr:"cu"},{country:"Czech Republic",abbr:"cz"},{country:"Egypt",abbr:"eg"},{country:"France",abbr:"fr"},{country:"Germany",abbr:"de"},{country:"Greece",abbr:"gr"},{country:"Hong Kong",abbr:"hk"},{country:"Hungary",abbr:"hu"},{country:"India",abbr:"in"},{country:"Indonesia",abbr:"id"},{country:"Ireland",abbr:"ie"},{country:"Israel",abbr:"il"},{country:"Italy",abbr:"it"},{country:"Japan",abbr:"jp"},{country:"Latvia",abbr:"lv"},{country:"Lithuania",abbr:"lt"},{country:"Malaysia",abbr:"my"},{country:"Mexico",abbr:"mx"},{country:"Morocco",abbr:"ma"},{country:"Netherlands",abbr:"nl"},{country:"New Zealand",abbr:"nz"},{country:"Nigeria",abbr:"ng"},{country:"Norway",abbr:"no"},{country:"Philippines",abbr:"ph"},{country:"Poland",abbr:"pl"},{country:"Portugal",abbr:"pt"},{country:"Romania",abbr:"ro"},{country:"Russia",abbr:"ru"},{country:"Saudi Arabia",abbr:"sa"},{country:"Serbia",abbr:"rs"},{country:"Singapore",abbr:"sg"},{country:"Slovakia",abbr:"sk"},{country:"Slovenia",abbr:"si"},{country:"South Africa",abbr:"za"},{country:"South Korea",abbr:"kr"},{country:"Sweden",abbr:"se"},{country:"Switzerland",abbr:"ch"},{country:"Taiwan",abbr:"tw"},{country:"Thailand",abbr:"th"},{country:"Turkey",abbr:"tr"},{country:"UAE",abbr:"ae"},{country:"Ukraine",abbr:"ua"},{country:"United Kingdom",abbr:"gb"},{country:"United States",abbr:"us"},{country:"Venuzuela",abbr:"ve"}],
    tab: null,
    topheadlinesPage:1,
    topheadlinescountry:'co',
    topheadlinesQ: '',
    everythingPage:1,
    everythingQ: 'Trump',
    everythingFrom: '',
    everythingTo: '',
    date:null,
  }),
  created(){
    this.fetchDataTopHeadlines()
    this.fetchDataEverything()
  },
  watch:{
    topheadlinesPage(){
      this.fetchDataTopHeadlines()
    },
    topheadlinescountry(){
      this.fetchDataTopHeadlines()
    },
    everythingPage(){
      this.fetchDataEverything()
    },
    everythingFrom(){
      this.fetchDataEverything()
    },
    everythingTo(){
      this.fetchDataEverything()
    },
  },
  computed: {
    ...mapState(['topHeadlinesArticles','totalTopHeadlines','everythingArticles','totalEverything'])
  }
};
</script>
